// IMediaDecoder.cpp: IMediaDecoder NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "IMediaDecoder.h"
#include "MediaData.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

IMediaDecoder::IMediaDecoder()
{
	// o̓tB^zNA
	::ZeroMemory(m_aOutputDecoder, sizeof(m_aOutputDecoder));
}

IMediaDecoder::~IMediaDecoder()
{

}

void IMediaDecoder::Reset()
{
	// ̃tB^Zbg
	for(DWORD dwOutputIndex = 0 ; dwOutputIndex < GetOutputNum() ; dwOutputIndex++){
		if(m_aOutputDecoder[dwOutputIndex].pDecoder){
			m_aOutputDecoder[dwOutputIndex].pDecoder->Reset();
			}
		}
}

const bool IMediaDecoder::SetOutputDecoder(IMediaDecoder *pDecoder, const DWORD dwOutputIndex, const DWORD dwInputIndex)
{
	// o̓tB^Zbg
	if(dwOutputIndex < GetOutputNum()){
		m_aOutputDecoder[dwOutputIndex].pDecoder = pDecoder;
		m_aOutputDecoder[dwOutputIndex].dwInputIndex = dwInputIndex;
		return true;
		}

	return false;
}

const bool IMediaDecoder::OutputMedia(CMediaData *pMediaData, const DWORD dwOutptIndex)
{
	// ftHg̏o͏

	// ̃tB^Ƀf[^n
	if(dwOutptIndex < GetOutputNum()){
		if(m_aOutputDecoder[dwOutptIndex].pDecoder){
			return m_aOutputDecoder[dwOutptIndex].pDecoder->InputMedia(pMediaData, m_aOutputDecoder[dwOutptIndex].dwInputIndex);
			}
		}

	// ̃tB^ȂƂ̓f[^j
	if(pMediaData)pMediaData->Delete();

	return false;
}


IMediaDecoder::CLockObject::CLockObject()
{
	// NeBJZNV
	::InitializeCriticalSection(&m_CriticalSection);
}

IMediaDecoder::CLockObject::~CLockObject()
{
	// NeBJZNV폜
	::DeleteCriticalSection(&m_CriticalSection);
}

void IMediaDecoder::CLockObject::Lock(void)
{
	// NeBJZNV擾
	::EnterCriticalSection(&m_CriticalSection);
}

void IMediaDecoder::CLockObject::Unlock(void)
{
	// NeBJZNVJ
	::LeaveCriticalSection(&m_CriticalSection);
}
	
IMediaDecoder::CLockBlock::CLockBlock(CLockObject *pLockObject)
	: m_pLockObject(pLockObject)
{
	// bN擾
	m_pLockObject->Lock();
}

IMediaDecoder::CLockBlock::~CLockBlock()
{
	// bNJ
	m_pLockObject->Unlock();
}
